###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 2.1

###################################################
# These line will be removed when this is packaged!
load("./data/data_Boulder_2.Rdata")
###################################################

# Load useful libraries
if (!require("forecast")){install.packages("forecast")}

# Store the data in a conveniently named variable
y <- data_Boulder_2

# First we plot the complete time series. We use the function plot
plot(y)

# Produce the seasonal plot of the last 4 years. We use the function seasonplot from the forecast package
z <- window(y,start=c(2011,1))
seasonplot(z)

###################################################
# Optional steps
###################################################

# An alternative function to produce seasonal plots can be found in the package TStools
if (!require("TStools")){
  if (!require("devtools")){install.packages("devtools")}
  devtools::install_github("trnnick/TStools")}

# Now we call function seasplot
seasplot(z)
# With seasplot we can produce several variants of the seasonal plot easily
# Seasonal boxplots
seasplot(z,outplot=2)
# Seasonal subseries plot
seasplot(z,outplot=3)
# Seasonal distribution plot
seasplot(z,outplot=4)
