###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 2.10

###################################################
# These line will be removed when this is packaged!
load("./data/data_Netflix_2.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_Netflix_2

# Plot time series
plot(y,main="Netflix")

# Calculate mean and median
apply(y,2,mean,na.rm=TRUE)
apply(y,2,median,na.rm=TRUE)

# Calculate growth
n <- dim(y)[1]
# Store growths in z
z <- array(NA,c(n,1))
for (i in 1:(n-4)){
  z[i+4,] <- 100*(y[i+4,1] - y[i,1])/y[i,1]
}
# Convert z into time series copying properties from y
z <- ts(z,frequency=frequency(y),end=end(y))
# Plot growths
plot(cbind(y,z))

###################################################
# Optional steps
###################################################

# Loops are wasteful. We should avoid them whenever we can.
# z can be calculated without a loop
t <- 5:n
z2 <- 100*(y[t,1] - y[t-4,1])/y[t-4,1]
# Add first year (that cannot be calculated)
z2 <- c(rep(NA,4),z2)
# Transform to time series
z2 <- ts(z2,frequency=frequency(y),end=end(y))
# Check if they are the same (ignoring NAs)
all(z2 == z,na.rm=TRUE)
