###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 2.12

###################################################
# These line will be removed when this is packaged!
load("./data/data_Inauguration.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_Inauguration

# Remove the Obama years (will use for the second part of the exercise)
n <- dim(y)[1]
y <- y[c(-(n-1),-n),]

# Calculate descriptive statistics. The function summary is handy for this.
summary(y[,2])

# Plot the series
plot(y[,1],y[,2],xlab="Year",ylab="Temperature",type="o")

# Visualise with boxplot and histogram. Use functions boxplot and hist
boxplot(y[,2],ylab="Tempeature")
hist(y[,2],xlab="Temperature")

# Construct 95% prediction intervals
a <- 0.95
# Using normal distribution
PInorm <- mean(y[,2]) + c(-1,1)*abs(qnorm((1-a)/2))*sd(y[,2])
# Empirical prediction intervals are easily calculated using the function quantile
PIemp <- quantile(y[,2],(((1-a)/2)+c(0,a)))
print(rbind(PInorm,PIemp))
# Note: quantile accepts the type argument which sets how to calculate the prediction intervals.
# Section 2.8.2 suggests type=5. We leave the default type=7. For the exact differences type: ?quantile

# Obama datapoints
obama <- data_Inauguration[(n-1):n,]

# Visualise
if (!require("RColorBrewer")){install.packages("RColorBrewer")}
cmp <- brewer.pal(3,"Set1")
xx <- range(data_Inauguration[,1])
yy <- range(c(data_Inauguration[,2],PInorm,PIemp))
plot(y[,1],y[,2],xlab="Year",ylab="Temperature",type="o",xlim=xx,ylim=yy)
lines(obama[,1],c(1,1)*PInorm[1],col=cmp[2],lty=2)
lines(obama[,1],c(1,1)*PInorm[2],col=cmp[2],lty=2)
lines(obama[,1],c(1,1)*PIemp[1],col=cmp[3],lty=2)
lines(obama[,1],c(1,1)*PIemp[2],col=cmp[3],lty=2)
points(obama[,1],obama[,2],col=cmp[1],pch=2)
legend("bottomleft",c("Data","PI Normal","PI Empirical","Obama"),col=c("black",cmp[c(2,3,1)]),lty=c(1,2,2,NA),pch=c(1,NA,NA,2))
