###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 2.13

###################################################
# These line will be removed when this is packaged!
load("./data/data_DC_Weather_2.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_DC_weather_2

# Calculate errors
e <- matrix(rep(y[,1],5),ncol=5) - y[,2:6]
# Remove rows with missing errors
e <- e[apply(is.na(e),1,sum)==0,]

# Calculate mean and standard deviation
sdev <- apply(e,2,sd)
mn <- apply(e,2,mean)

# Calculate the 90% and 95% PIs
a <- c(0.9,0.95)

# Calculate 80% PI
quantile(e[,1],c(0.1,0.9))
# Using normal distribution
# 90%
PInorm90L <- mn - abs(qnorm((1-a[1])/2)) * sdev
PInorm90U <- mn + abs(qnorm((1-a[1])/2)) * sdev
# 95%
PInorm95L <- mn - abs(qnorm((1-a[2])/2)) * sdev
PInorm95U <- mn + abs(qnorm((1-a[2])/2)) * sdev
# Empirical
# 90%
PIemp90L <- apply(e,2,quantile,(1-a[1])/2)
PIemp90U <- apply(e,2,quantile,a[1]+(1-a[1])/2)
# 95%
PIemp95L <- apply(e,2,quantile,(1-a[2])/2)
PIemp95U <- apply(e,2,quantile,a[2]+(1-a[2])/2)

# Report results
PI90 <- rbind(PIemp90L,PIemp90U,PInorm90L,PInorm90U)
PI95 <- rbind(PIemp95L,PIemp95U,PInorm95L,PInorm95U)
rownames(PI90) <- rownames(PI95) <- c("Empirical Lower","Empirical Upper","Normal Lower","Normal Upper")
colnames(PI90) <- colnames(PI95) <- paste0(1:5,"-Day")
# Report 90%
print(round(PI90,3))
# Report 95%
print(round(PI95,3))
