###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 2.5

###################################################
# These line will be removed when this is packaged!
load("./data/data_Boulder_2.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_Boulder_2

# Calculate statistics for the complete series
descr_y <- c(mean(y), median(y), mad(y), sd(y))
names(descr_y) <- c("Mean","Median","MAD","S")
print(descr_y)

# Calculate statistics for each month

# First we need to reshape the data as needed
z <- matrix(y,nrow=12)
rownames(z) <- month.abb
colnames(z) <- unique(format(as.Date(time(y), format="%d/%m/%Y"),"%Y"))
print(z)

# and now we calculate the statistics
mean_z <- apply(z,1,mean)
median_z <- apply(z,1,median)
mad_z <- apply(z,1,mad)
sd_z <- apply(z,1,sd)
descr_z <- cbind(mean_z,median_z,mad_z,sd_z)
colnames(descr_z) <- names(descr_y)

# Print both sets of statistics
print(descr_y)
print(descr_z)

###################################################
# Optional steps
###################################################

# Plotting helps!
plot(descr_z[,1],type="o",main="Mean",col="blue",ylab="Temperature",xlab="Month",xaxt="n")
axis(1,at=1:12,labels=month.abb)
lines(c(1,12),descr_y[1]*c(1,1),col="red")
legend("topleft",c("Overall","Monthly"),col=c("blue","red"),pch=c(1,NA),lty=1)

# Similarly you can produce plots for the remaining statistics
