###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 3.11

###################################################
# These line will be removed when this is packaged!
load("./data/data_Dulles_2.Rdata")
###################################################

if (!require("forecast")){install.packages("forecast")}

# Store the data in a conveniently named variable
y <- data_Dulles_2
n <- length(y)

# The different estimation samples can be solved as in 3.10
# Here we will quickly use the two separate data ranges

teststr <- c(2004,2011)
l <- length(teststr)

MAE <- array(NA,c(l,1),dimnames=list(c("2004-2015","2011-2015"),c("LES")))

# We will automate the calculation
for (i in 1:l){

  # Specify the test set
  test <- window(y,start=teststr[i])
  m <- length(test)

  # Fit optimal LES
  fit <- ets(window(y,end=teststr[i]-1),model="AAN")

  # Produce multi-step forecasts. We use the argument h in the forecats function
  frc <- forecast(fit,h=m)$mean
  MAE[i] <- mean(abs(test-frc))

}

print(round(MAE,3))
