###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 4.2

# There is no default function that implements pure seasonal exponential smoothing, so we will have to construct this manually.
# First, let us get the data
y <- cbind(c(50,30,20,90,55,35,15,80),
           c(rep(NA,4),50,30,20,90))
y <- ts(y,frequency=4)
print(y)

# Now let us produce the forecast
gamma <- 0.5
frc <- vector("numeric",4)
for (i in 1:4){
  frc[i] <- gamma*y[4+i,1] + (1-gamma)*y[4+i,2]
}
frc <- ts(frc,frequency=4,start=c(3,1))
print(frc)

# Visualise the results
ts.plot(y[,1],frc,col=c("black","red"))
legend("topleft",c("Historical","Forecast"),lty=1,col=c("black","red"))
