###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 4.3

###################################################
# These line will be removed when this is packaged!
load("./data/data_US_Retail_Sales_2.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_US_Retail_Sales_2

# For this exercise we will directly develop a Holt-Winters forecast
# We can do that using the ets function from the forecast package
if (!require("forecast")){install.packages("forecast")}

# First set of forecasts
fitsample <- window(y,end=c(2013,1))
fit <- ets(fitsample,model="AAZ",damped=FALSE)  # We are not permitting damped trend for this exercise
frc <- forecast(fit,h=12)
plot(frc)

# Second set of forecasts
fitsample <- window(y,end=c(2014,1))
fit <- ets(fitsample,model="AAZ",damped=FALSE)  # We are not permitting damped trend for this exercise
frc <- forecast(fit,h=12)
plot(frc)
