###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 4.4

###################################################
# These line will be removed when this is packaged!
load("./data/data_Job_openings.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_Job_openings

if (!require("forecast")){install.packages("forecast")}

# First, plot the time series and a seasonal plot
plot(y)
seasonplot(y)
# The inclusion of trend in the seasonal plot makes it difficult to read
# See the optional steps for a helpful alternative

# Fit some alternative Holt-Winters methods and assess them
fit <- vector("list",2)
# Addtive
fit[[1]] <- ets(y,model="AAA",damped=FALSE)  # We are not permitting damped trend for this exercise
# MUltiplicative
fit[[2]] <- ets(y,model="MAM",damped=FALSE)
# Get MSE of models (note: they have the same number of parameters and are estimated on the same sample,
# therefore using in-sample MSE to compare them is valid)
MSE <- unlist(lapply(fit,function(x){x$mse}))
names(MSE) <- c("Additive","Multiplicative")
print(MSE)

# Use the most accurate model
fit_use <- fit[[which(MSE==min(MSE))]]

# We fit a non-seasonal LTE to compare against
fit_lte <- ets(y,model="AAN")

# Produce forecasts and plot them
frc_seasonal <- forecast(fit_use,h=12)
frc_lte <- forecast(fit_lte,h=12)

par(mfrow=c(1,2))
plot(frc_seasonal)
plot(frc_lte)
par(mfrow=c(1,1))

# We can use holdout to compare based on error measures
