###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 4.5

###################################################
# These line will be removed when this is packaged!
load("./data/data_Alcohol_sales.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_Alcohol_sales

if (!require("forecast")){install.packages("forecast")}

# First, plot the time series and a seasonal plot
plot(y)
seasonplot(y)

# The time series is clearly trended and seasonal, so we will develop the two Holt-Winters alternatives
fit <- vector("list",2)
xt <- time(y)
fitsample <- window(y,end=tail(xt,37)[1])
holdout <- window(y,start=tail(xt,36)[1])
# Addtive
fit[[1]] <- ets(fitsample,model="AAA",damped=FALSE)
# MUltiplicative
fit[[2]] <- ets(fitsample,model="MAM",damped=FALSE)
# Get MSE of models (note: they have the same number of parameters and are estimated on the same sample,
# therefore using in-sample MSE to compare them is valid)
MSE <- unlist(lapply(fit,function(x){x$mse}))
names(MSE) <- c("Additive","Multiplicative")
print(MSE)
# MSE suggests to use the multiplicative model

# Let us validate that on holdout errors
frc <- array(NA,c(length(holdout),length(fit)),dimnames=list(time(holdout),names(MSE)))
for (i in 1:2){
  frc[,i] <- forecast(fit[[i]],h=length(holdout))$mean
}
# calculate errors
e <- matrix(rep(holdout,2),ncol=2) - frc
MAE <- apply(abs(e),2,mean)
print(round(MAE,3))
# The MAE result agree, the multiplicative model is best
