###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 4.7

###################################################
# These line will be removed when this is packaged!
load("./data/data_Titanic_box_office.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_Titanic_box_office

if (!require("forecast")){install.packages("forecast")}

# First, plot the time series and a seasonal plot
plot(y)
seasonplot(y)

# The time series is clearly trended and seasonal, and the seasonality is multiplicative
xt <- time(y)
fitsample <- window(y,end=tail(xt,4*7+1)[1])
holdout <- window(y,start=tail(xt,4*7)[1])
fit <- ets(fitsample,model="MAM",damped=FALSE)

# Produce forecasts and plot
frc <- forecast(fit,h=28)
plot(frc,ylim=c(0,5200))
lines(holdout,col="red",lwd=2)
legend("topright",c("Holdout","Forecast"),col=c("red","blue"),lty=1)

# Try increasing the estimation sample by 1 period and repeat the analysis!
