###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 4.8

###################################################
# These line will be removed when this is packaged!
load("./data/data_Gas_prices_Ch4.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_Gas_prices_Ch4

if (!require("forecast")){install.packages("forecast")}

# First, plot the time series and a seasonal plot
plot(y)
seasonplot(y)

# The time series is clearly trended and seasonal, and the seasonality is multiplicative
fitsample <- window(y,end=c(2012,12))
holdout <- window(y,start=c(2013,1))

# Develop seasonal models
fit <- vector("list",2)
# Addtive
fit[[1]] <- ets(fitsample,model="AAA",damped=FALSE)
# MUltiplicative
fit[[2]] <- ets(fitsample,model="MAM",damped=FALSE)

# Get MSE of models (note: they have the same number of parameters and are estimated on the same sample,
# therefore using in-sample MSE to compare them is valid)
MSE <- unlist(lapply(fit,function(x){x$mse}))
names(MSE) <- c("Additive","Multiplicative")
print(MSE)
# MSE suggests to use the additive model

# Let us validate that on holdout errors
frc <- array(NA,c(length(holdout),length(fit)),dimnames=list(time(holdout),names(MSE)))
for (i in 1:2){
  frc[,i] <- forecast(fit[[i]],h=length(holdout))$mean
}
# calculate errors
e <- matrix(rep(holdout,2),ncol=2) - frc
MAE <- apply(abs(e),2,mean)
print(round(MAE,3))
# The MAE result agree, the additive model is best
