###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 5.2

###################################################
# These line will be removed when this is packaged!
load("./data/data_GDP_change_2.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_GDP_change_2
y <- window(y,start=start(y),end=2015)
n <- length(y)

# Experiment's settings
horizon <- 6
fitsample_end <- c(2007,2009)
m <- length(fitsample_end)

RMSE <- alpha <- array(NA,c(m,1),dimnames=list(fitsample_end,"SES"))
fit <- frc <- vector("list",m)

for (i in 1:m){

  # Create test set
  fitsample <- window(y,end=c(fitsample_end[i]))

  # Fit ETS(A,N,N)
  fit[[i]] <- ets(fitsample,model="ANN")
  # The ets function saves a lot of interestig information
  # You can check the different information store by names(fit[[i]]) or ?ets
  RMSE[i] <- sqrt(fit[[i]]$mse)   # This is in-sample RMSE
  alpha[i] <- fit[[i]]$par[1]     # Smoothing parameter alpha
  # When we produce foreasts we are also given model based prediction intervals
  # The prediction interval is controlled by the argument level
  frc[[i]] <- forecast(fit[[i]],h=horizon,level=95)

}

print(RMSE)
print(alpha)

par(mfrow=c(m,1))
for (i in 1:m){
  plot(frc[[i]])
}

# To retrive the prediction interval values we can use
names(frc[[1]])
# The lower and upper contain the prediction intervals, while mean contains the point forecast
cbind(frc[[1]]$lower,frc[[1]]$mean,frc[[1]]$upper)
# which is what frc prints-out
frc[[1]]
