###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 6.12
# We will show the solution for one time series. The approach for the remaining time series is the same

###################################################
# These line will be removed when this is packaged!
load("./data/data_GDP_change_2.Rdata")
###################################################

if (!require("forecast")){install.packages("forecast")}

# Store the data in a conveniently named variable
y <- data_GDP_change_2
n <- length(y)
m <- 4

fitsample <- ts(y[1:(n-m)],frequency=frequency(y),start=start(y))
test <- ts(y[(n-m+1):n],frequency=frequency(y),end=end(y))

fit <- auto.arima(fitsample)
frc <- forecast(fit,h=m)

# The forecast function produce prediction intervals as well, which can be accessed easily
# The desired intervals can be requested using the argument level
frc$lower
frc$upper
plot(frc)
lines(test,col="red")
legend("topright",c("Forecast","Holdout"),col=c("blue","red"),lty=c(NA,1),pch=c(19,NA))

e <- test - frc$mean
# Error metrics
MAE <- mean(abs(e))
MAPE <- mean(abs(e)/test)*100
E <- rbind(MAE,MAPE)
print(round(E,3))
