###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 6.13

###################################################
# These line will be removed when this is packaged!
load("./data/data_US_Retail_Sales_2_SA.Rdata")
###################################################

if (!require("forecast")){install.packages("forecast")}

# Store the data in a conveniently named variable
y <- data_US_Retail_Sales_2_SA[,1]
n <- length(y)
m <- 12

fitsample <- ts(y[1:(n-m)],frequency=frequency(y),start=start(y))
test <- ts(y[(n-m+1):n],frequency=frequency(y),end=end(y))

# We can control the presence of constant with the arguments allow.drift and allow.mean, which by definition are allowed
fit <- frc <- vector("list",2)
fit[[1]] <- auto.arima(fitsample)
fit[[2]] <- auto.arima(fitsample,allowdrift=FALSE)
for (i in 1:2){
  frc[[i]] <- forecast(fit[[i]],h=m)
}
# Plot forecasts and PIs
par(mfrow=c(1,2))
plot(frc[[1]])
plot(frc[[2]])
par(mfrow=c(1,1))

# Compare values of forecasts
cbind(frc[[1]]$mean,frc[[2]]$mean)
