###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 6.20

###################################################
# These line will be removed when this is packaged!
load("./data/data_SP500_daily.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_SP500_daily
n <- length(y)

# First we plot the data to see what we are dealing with
plot(y)

# Let us transform the data into returns
z <- 100*(y[2:n]-y[1:(n-1)])/y[1:(n-1)]
z <- ts(z,frequency=frequency(y),end=end(y))
plot(z)

# We can build GARCH models in R using the function garch in the tseries package
library(tseries)
fit1 <- garch(z,order=c(1,1))
print(fit1)
# We can get the AIC of the fit using the AIC function
aic <- AIC(fit1)
print(aic)

# Let us attempt a simpler GARCH
fit2 <- garch(z,order=c(1,0))
AIC(fit2) < aic
# This is not a better model according to AIC

# A more complex GARCh would be
fit3 <- garch(z,order=c(2,1))
AIC(fit3) < aic
# Which also fails to beat the initial model in terms of of AIC.

# We can use this approach to find a GARCH that has a ood fit and is parsimonious

# There are multiple R packages that can help in fitting GARCH models with various options
# Potential alternatives are:
#   bayesGARCH
#   betategarch
#   dynamo
#   fGarch
#   rgarch
#   rugarch
