###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 6.4

###################################################
# These line will be removed when this is packaged!
load("./data/data_Dulles_2.Rdata")
###################################################

if (!require("forecast")){install.packages("forecast")}

# Store the data in a conveniently named variable
y <- data_Dulles_2

# For this exercise we merely need to restrict the starting date of the time series
# and the rest is the same as for exercise 2.11
y <- window(y,start=1986)
n <- length(y)

# The different estimation samples can be solved as in 3.10
# Here we will quickly use the two separate data ranges

teststr <- c(2004,2011)
l <- length(teststr)

MAE <- array(NA,c(l,1),dimnames=list(c("2004-2015","2011-2015"),"ARIMA"))

# We will automate the calculation
for (i in 1:l){

  # Specify the test set
  test <- window(y,start=teststr[i])
  m <- length(test)

  # Fit ARIMA
  fit <- auto.arima(window(y,end=teststr[i]-1))

  # Produce forecasts
  frc <- array(NA,c(m,1))
  for (j in 1:m){
    # We run a rolling origin evaluation. At each iteration (i) we need to provide the current fitting sample
    # This must be a ts class object for the forecast package functions to work properly
    fitsample <- y[1:(n-m+j-1)]
    fitsample <- ts(fitsample,frequency=frequency(y),start=start(y))
    fitrol <- Arima(fitsample,model=fit)
    frc[j,] <- forecast(fitrol,h=1)$mean
  }

  MAE[i] <- mean(abs(test-frc))

}

print(round(MAE,3))
