###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 6.7

###################################################
# These line will be removed when this is packaged!
load("./data/data_US_Retail_Sales_2.Rdata")
###################################################

if (!require("forecast")){install.packages("forecast")}

# Store the data in a conveniently named variable
y <- data_US_Retail_Sales_2

# First we find the lambda for the Box-Cox transformation
lambda <- BoxCox.lambda(y)
# We can use this to as an argument to the Arima and auto.arima functions.
# The benefit of doing that, instead of manually transforming is that we always get the results on the original data
# We could have done the same for the log transformation with lambda=0

fit1 <- Arima(y,c(1,0,1),c(0,1,0),lambda=lambda)
print(fit1)
fit2 <- auto.arima(y,lambda=lambda)
print(fit2)
# fit <- auto.arima(y,lambda=0) # log transformation

# Follow the logic of exercise 6.6 to build and diagnose potential ARIMA models
