###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 6.8

###################################################
# These line will be removed when this is packaged!
load("./data/data_US_Retail_Sales_2.Rdata")
###################################################

if (!require("forecast")){install.packages("forecast")}

# Store the data in a conveniently named variable
y <- data_US_Retail_Sales_2

plot(y)
loc <- which(time(y)==2001.75)
points(2001.75,y[loc],col="red",pch=19) # 2001.75 is Oct 2001. That is 9/12 + 2001. (Not 10/12 as 12/12 is the next year!)
legend("topleft","Outlier",pch=19,col="red")

# There are many strategies to replace the outlier. Here we will follow the suggestion in section 6.6 of the book.
fit1 <- auto.arima(y)
# Extract from the fitted values the replacement for the outlier
replacement <- fit1$fitted[loc]
z <- y
z[loc] <- replacement

fit2 <- auto.arima(z)
print(fit1)
print(fit2)

# We can easily repeat the same analysis using log or Box-Cox transformations with the lambda argument.
