###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercises 6.9

###################################################
# These line will be removed when this is packaged!
load("./data/data_US_Retail_Sales_2_SA.Rdata")
###################################################

if (!require("forecast")){install.packages("forecast")}

# Store the data in a conveniently named variable
y <- data_US_Retail_Sales_2_SA[,1]

fitsample <- window(y,end=c(2012,12))
test <- window(y,start=c(2013,1))
m <- length(test)

fit <- vector("list",2)
# Fit model on original data
fit[[1]] <- auto.arima(fitsample,lambda=0)
# Fit model on adjusted data
loc <- which(time(y)==2001.75)
fitsamplec <- fitsample
fitsamplec[loc] <- fit[[1]]$fitted[loc]
fit[[2]] <- auto.arima(fitsamplec,lambda=0)

# Produce forecasts
frc <- array(NA,c(m,2),dimnames=list(time(test),c("Original","Adjusted")))
for (i in 1:2){
  frc[,i] <- forecast(fit[[i]],h=m)$mean
}

e <- matrix(rep(test,2),ncol=2) - frc
# Error metrics
MAE <- apply(abs(e),2,mean)
MAPE <- apply(abs(e)/matrix(rep(test,2),ncol=2),2,mean)*100
E <- rbind(MAE,MAPE)
print(round(E,3))
