###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 7.1

###################################################
# These line will be removed when this is packaged!
load("./data/data_Exercise_7_1.Rdata")
###################################################

# Store the data in a conveniently named variable
x <- data_Exercise_7_1

# Regression models can be build quite easily if we store our data as data.frames.
# The data in this exercise is already a data frame. We can use the function as.data.frame to transform arrays/matrices to data.frames

# Some initial exploration
cor(x)
plot(x)

# Regression sales on spots
fit1 <- lm(sales ~ spots, data=x)
summary(fit1)

# Get p-values and evaluate with a = 0.1
pval <- summary(fit1)$coefficients[,4]
pval <= 0.1

# R^2 and S are given by summary(fit1) above

xnew <- data.frame("spots"=20)
frc <- predict(fit1,xnew,interval="prediction")  # We use the argument interval="prediction" to get prediction intevals. See ?prediction.lm
