###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 7.2

###################################################
# These line will be removed when this is packaged!
load("./data/data_Exercise_7_2.Rdata")
###################################################

# Store the data in a conveniently named variable
x <- data_Exercise_7_2

# Regression models can be build quite easily if we store our data as data.frames.
# The data in this exercise is already a data frame. We can use the function as.data.frame to transform arrays/matrices to data.frames

# Some initial exploration
cor(x)
plot(x)

# Regression sales on price
fit1 <- lm(sales ~ price, data=x)
summary(fit1)

# Regression revenues on price
fit2 <- lm(revenue ~ price, data=x)
summary(fit2)

# Get p-values and evaluate with a = 0.05
pval1 <- summary(fit1)$coefficients[,4]
pval2 <- summary(fit2)$coefficients[,4]
pval1 <= 0.05
pval2 <= 0.05

# Extract R squared (given by summary())
Rsq <- c(summary(fit1)$r.squared,summary(fit2)$r.squared)
names(Rsq) <- c("Sales~Price","Revenue~Price")
print(round(Rsq,3))
