###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 7.3

###################################################
# These line will be removed when this is packaged!
load("./data/data_Exercise_7_1.Rdata")
###################################################

# Store the data in a conveniently named variable
x <- data_Exercise_7_1

# Regression models can be build quite easily if we store our data as data.frames.
# The data in this exercise is already a data frame. We can use the function as.data.frame to transform arrays/matrices to data.frames

# Some initial exploration
cor(x)
plot(x)

# Regression sales on spots
fit1 <- lm(sales ~ spots, data=x)
summary(fit1)

# Regression sales on time
x2 <- data.frame("time"=1:dim(x)[1]) # We could have used the existing week variable as well
fit2 <- lm(sales~time,data=cbind(x,x2))
summary(fit2)

# Get p-values and evaluate with a = 0.1
pval <- summary(fit2)$coefficients[,4]
pval <= 0.05
