###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 7.6

###################################################
# These line will be removed when this is packaged!
load("./data/data_Housing_2.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_Housing_2

y_estim <- window(data_Housing_2,end=c(2012,12))
y_test <- window(data_Housing_2,start=c(2013,1),end=c(2015,12))
x <- as.data.frame(y_estim)
xnew <- as.data.frame(y_test)

# Preliminary analysis
cor(x)
plot(x)

# Regression sales on price
fit1 <- lm(median_price~time, data=x)
summary(fit1)

# Predict 2013:Q1 to 2015:Q4 and construct 95% PIs
frc <- predict(fit1,xnew,interval="prediction",level=0.9)

# Plot predictions
if (!require("RColorBrewer")){install.packages("RColorBrewer")}
cmp <- brewer.pal(3,"Set1")
frc <- ts(frc,frequency=frequency(y_test),start=start(y_test))
yy <- range(c(y_test[,4],frc))
plot(y_test[,4],ylim=yy,ylab="Median Price")
lines(frc[,1],col=cmp[1])
lines(frc[,2],col=cmp[2],lty=2)
lines(frc[,3],col=cmp[2],lty=2)
legend("topleft",c("Actuals","Forecast","90% PIs"),col=c("black",cmp[1:2]),lty=c(1,1,2,2))
