###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 7.8

###################################################
# These line will be removed when this is packaged!
load("./data/data_Gas_prices_1.Rdata")
###################################################

# Store the data in a conveniently named variable
y <- data_Gas_prices_1
n <- dim(y)[1]

# Construct a data.frame with the required variables
# Note that we apply all transformations and lags as necessary
x <- data.frame("log_unleaded"=log(y[,1]), "log_L1_crude_price"=log(c(NA,y[1:(n-1)])))
# Test set is 2 years
m <- 24

# Split sample
x_estim <- x[1:(n-m),]
x_test <- x[(n-m+1):n,]

# fit model
fit <- lm(log_unleaded~log_L1_crude_price,data=x_estim)
summary(fit)

# Predict last two years and construct 90% PIs
log_frc <- predict(fit,x_test,interval="prediction",level=0.9)
frc <- exp(log_frc)

# Plot predictions
if (!require("RColorBrewer")){install.packages("RColorBrewer")}
cmp <- brewer.pal(3,"Set1")
yy <- range(c(exp(x_test[,1]),frc))
plot(exp(x_test[,1]),ylim=yy,ylab="Unleaded")
lines(frc[,1],col=cmp[1])
lines(frc[,2],col=cmp[2],lty=2)
lines(frc[,3],col=cmp[2],lty=2)
legend("bottomright",c("Actuals","Forecast","90% PIs"),col=c("black",cmp[1:2]),lty=c(1,1,2,2))
