###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 8.10

###################################################
# These line will be removed when this is packaged!
load("./data/data_Gas_prices_1.Rdata")
###################################################

# Store the data in a conveniently named variable
x <- data_Gas_prices_1
k <- dim(x)[2]
n <- dim(x)[1]
lbls <- colnames(x)
# Construct L3 lags for x
x <- cbind(x,
           rbind(matrix(rep(NA,k*3),nrow=3),
                   x[c(-n+2,-n+1,-n),]))
colnames(x) <- c(lbls,paste0("L3_",lbls))
x_estim <- window(x,end=c(2008,12))
x_test <- window(x,start=c(2009,1))

fit <- lm(unleaded~L3_crude_price+L3_sp500+L3_rr_sales+L3_unemp,data=x_estim)
summary(fit)

frc <- predict(fit,x_test,interval="prediction",level=0.9)
# Remove Jan 2009 and Feb 2009
frc <- frc[c(-1,-2),]

# Visualise
if (!require("RColorBrewer")){install.packages("RColorBrewer")}
cmp <- brewer.pal(3,"Set1")

yy <- range(c(x_test[,1],frc))
plot(x_test[c(-1,-2),1],ylim=yy,type="l")
lines(frc[,1],col=cmp[1])
lines(frc[,2],col=cmp[2],lty=2)
lines(frc[,3],col=cmp[2],lty=2)

legend("topleft",c("Actual","Forecast t+3","Prediction Intervals"),col=c("black",cmp[1:2]),lty=c(1,1,2))
