###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 8.2

###################################################
# These line will be removed when this is packaged!
load("./data/data_Exercise_7_2.Rdata")
###################################################

# Store the data in a conveniently named variable
x <- data_Exercise_7_2

# Some initial exploration
cor(x)
plot(x)

# Regress sales on spots and price
fit1 <- lm(sales ~ advertising+price, data=x)
summary(fit1)

# Diagnose model
par(mfrow=c(2,2))
plot(fit1)
par(mfrow=c(1,1))

# Alternatively we can extract the residuals and produce any plot we want manually
resid <- fit1$residuals
fitted <- fit1$fitted.values
par(mfrow=c(2,2))
plot(fitted,resid)
plot(x$price,resid)
plot(x$advertising,resid)
hist(resid)
par(mfrow=c(1,1))

# Alternatively the package car provides useful functions for regression diagnostics

# Compare the multiple regression model with the bivariate one
fit2 <- lm(sales ~ price, data=x)
adjRsq <- c(summary(fit1)$adj.r.squared,summary(fit2)$adj.r.squared)
names(adjRsq) <- c("Sales~Advertising+Price","Sales~Price")
print(round(adjRsq,3))
