###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 9.10

###################################################
# These line will be removed when this is packaged!
load("./data/data_Gas_prices_2.Rdata")
###################################################

# Rename variable for convenience
x <- data_Gas_prices_2
# COnstruct lags
k <- dim(x)[2]
n <- dim(x)[1]
lbls <- colnames(x)
# COnstruct lags for x
x <- cbind(x,rbind(rep(NA,k),x[-n,]))
colnames(x) <- c(lbls,paste0("L1_",lbls))
# Seperate samples
x_estim <- window(x,end=c(2013,12))
x_test <- window(x,start=c(2014,1),end=c(2015,12))

# Fit model - Note that I can add logs in the model specification
fit <- lm(unleaded ~ log(L1_unleaded)+log(L1_crude_price)+log(L1_sp500)+log(L1_unemp)+log(L1_rr_sales),data=x_estim)
summary(fit)

# Calculate forecasts
frc <- predict(fit,x_test)

# Calculate errors
e <- x_test[,1] - frc
MAE <- mean(abs(e))
MAPE <- mean(abs(e)/x_test[,1])*100
print(round(rbind(MAE,MAPE),3))
