###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 9.11

###################################################
# These line will be removed when this is packaged!
load("./data/data_Gas_prices_2.Rdata")
###################################################

# Rename variable for convenience
x <- data_Gas_prices_2
# COnstruct lags - we need to increase these to t-3
k <- dim(x)[2]
n <- dim(x)[1]
lbls <- colnames(x)
# COnstruct lags for x
x <- cbind(x,
           rbind(matrix(rep(NA,k*3),nrow=3),
                 x[c(-n+2,-n+1,-n),]))
colnames(x) <- c(lbls,paste0("L3_",lbls))
# Seperate samples
x_estim <- window(x,end=c(2008,12))
x_test <- window(x,start=c(2009,1),end=c(2010,12))

# Fit model
fit <- lm(unleaded ~ log(L3_unleaded)+log(L3_crude_price)+log(L3_sp500)+log(L3_unemp)+log(L3_rr_sales),data=x_estim)
summary(fit)

# Calculate forecasts
frc <- predict(fit,x_test)

# Calculate errors
e <- x_test[,1] - frc
MAE <- mean(abs(e))
MdAE <- median(abs(e))
MAPE <- mean(abs(e)/x_test[,1])*100
MdAPE <- median(abs(e)/x_test[,1])*100
print(round(rbind(MAE,MdAE,MAPE,MdAPE),3))
