###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 9.15

###################################################
# These line will be removed when this is packaged!
load("./data/data_Advert.Rdata")
###################################################

# Rename variable for convenience
x <- data_Advert

# The dummies are created internally by lm as needed
fit <- lm(sales ~ advert + I(advert^2) + type,data=x)
summary(fit)

par(mfrow=c(2,2))
plot(fit)
par(mfrow=c(1,1))
# Observation 1 is outlying and 22 may need some attention
# Let us construct indicator variables for these two points and estimate the model again
n <- dim(x)[1]
z <- array(0,c(n,2))
z[1,1] <- 1
z[22,2] <- 1
z <- cbind(x,z)
colnames(z)[4:5] <- c("D1","D22")
# Fit model
fit <- lm(sales ~ advert + I(advert^2) + type + D1 + D22,data=z)
summary(fit)
# D22 does not seem to have a significant effect
fit <- lm(sales ~ advert + I(advert^2) + type + D1,data=z)
summary(fit)

par(mfrow=c(2,2))
plot(fit)
par(mfrow=c(1,1))

# Let us try the logarithmic transformation
fit_log <- lm(log(sales) ~ log(advert) + I(log(advert)^2) + type + D1,data=z)
summary(fit_log)

par(mfrow=c(2,2))
plot(fit_log)
par(mfrow=c(1,1))

# Remember the statistics can be compared on the same data!
