###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 9.2

# Let us construct some quarterly time series with some random error
n <- 40
y <- ts(sin(2*pi*(1:n)/4)*3 + rnorm(n) + 10,frequency=4)
plot(y)

# Now we create the seasonal dummies
d <- matrix(rep(diag(rep(1,4)),ceiling(n/4)),nrow=n,byrow=TRUE)
d <- d[1:n,]
x <- cbind(y,d)
x <- as.data.frame(x)
colnames(x) <- c("y",paste0("Q",1:4))

# Model with 3 seasonal dummies
fit1 <- lm(y~Q1+Q2+Q3,data=x)
summary(fit1)

# Model with 4 seasonal dummies
fit2 <- lm(y~Q1+Q2+Q3+Q4,data=x)
summary(fit2)

# One seasonal dummy was automatically eliminated
