###################################################
# Principles of Business Forecasting 2e, 2017
# ord, K., Fildes, R. and Kourentzes, N.
# (Book website) - TO BE EDITED
#
# Companion scripts for R
###################################################

# Exercise 9.3

###################################################
# These line will be removed when this is packaged!
load("./data/data_WFJ_sales_2.Rdata")
###################################################

# Rename variable for convenience
y <- data_WFJ_sales_2
n <- dim(y)[1]
colnames(y)[2:6] <- paste0("d",1:5)

# We have 5 dummies, so we should use 4 (Always k-1 binary dummies).
# We will build alternative regressions with different set of dummies and compare the result in terms of fitted values

# All possible combinations (columns) are given by
cbn <- combn(1:5,4)
m <- dim(cbn)[2]

fit <- vector("list",m)
fitted <- array(NA,c(n,m),dimnames=list(NULL,paste0("Model",1:m)))
for (i in 1:m){
  frm <- as.formula(paste0("sales~",paste0("d",cbn[,i],collapse="+")))
  fit[[i]] <- lm(frm,data=y)
  fitted[,i] <- fit[[i]]$fitted.values
}

# We can see that the fitted values are always the same
print(fitted)
# Or check it to be 100% certain we did not miss any numerical difference
# If all columns are equal to the first, there are equal to each other as well
eq <- vector("logical",m-1)
for (i in 1:(m-1)){
  # we look up to the 10th decimal in precision, to avoid any differences due to rounding in storing the values
  eq[i] <- all(round(fitted[,1],10) == round(fitted[,1+i],10))
}
# Are all equal?
all(eq)
